/* GCC */
#include<iostream>
#include<algorithm>
#include<windows.h>
#include<clocale>
#include<vector>
#include<cstdio>
#include<map>

using namespace std;

const int N = 50+2;
char alpha[] = "åŪȲ賿";

bool is_upper(char c){
    for(char* i = alpha; *i != ''; ++i)
        if(c == *i)
            return true;
    return false;
}
bool cless(char a, char b){
    for(char* i = alpha; i; ++i){
        if(*i == a)
            return true;
        if(*i == b)
            return false;
    }
}
struct comp{
    comp(){}
    bool operator()(string a, string b){
        cout << a << ' ' << b << endl;
        for(int i = 0; i < min(a.size(), b.size()); ++i){
            if(a[i] == b[i])
                continue;
            if(cless(b[i], a[i]))
                return false;
            if(cless(a[i], b[i]))
                return true;
        }
        return a.size() < b.size();
    }
};

vector<string> all_names;
int sz;
vector< pair< pair<int, int>, char> > rules;
map<string, int> names, jobs;
string bnames[N], bjobs[N];
int get_name(string s){
    if(names.find(s) == names.end()){
        int sz = names.size();
        all_names.push_back(s);
        bnames[sz+1] = s;
        names[s] = sz+1;
    }
    return names[s];
}
int get_job(string s){
    if(jobs.find(s) == jobs.end()){
        int sz = jobs.size();
        bjobs[sz+1] = s;
        jobs[s] = sz+1;
    }
    return jobs[s];
}

int nxt(int i){ return (i+1)%sz; }
int prv(int i){ return (i+sz-1)%sz; }

bool urules[N][N];
int pnames[N][N], pjobs[N][N];
int table[N][N][2];
int level;

bool try_set(int pos, int num){
    if(num > 0){
        cout << "TRY SET " << pos << ' ' << num << " but now " << table[level][pos][0] << " here" << endl;
        if(table[level][pos][0] != 0 && table[level][pos][0] != num)
            return false;
        table[level][pos][0] = num;
        pnames[level][num] = pos;
        return true;
    }
    if(num < 0){
        cout << "TRY SET " << pos << ' ' << num << " but now " << table[level][pos][1] << " here" << endl;
        if(table[level][pos][1] != 0 && table[level][pos][1] != -num)
            return false;
        table[level][pos][1] = -num;
        pjobs[level][-num] = pos;
        return true;
    }
}

void rec(){
    bool updated = true;
    while(updated){
        updated = false;
        for(int i = 0; i < rules.size(); ++i){
            if(urules[level][i])
                continue;
            if(rules[i].first.first > 0 && pnames[level][rules[i].first.first] != -1){
                cout << "use rule " << i << endl;
                int pos = pnames[level][rules[i].first.first];
                if(rules[i].second == '>')
                    if(!try_set(prv(pos), rules[i].first.second))
                        return;
                if(rules[i].second == '<')
                    if(!try_set(nxt(pos), rules[i].first.second))
                        return;
                if(rules[i].second == '|')
                    if(!try_set((pos+sz/2)%sz, rules[i].first.second))
                        return;
                urules[level][i] = true;
                updated = true;
            }
            else if(rules[i].first.first < 0 && pjobs[level][-rules[i].first.first] != -1){
                cout << "use rule " << i << endl;
                int pos = pjobs[level][-rules[i].first.first];
                if(rules[i].second == '>')
                    if(!try_set(prv(pos), rules[i].first.second))
                        return;
                if(rules[i].second == '<')
                    if(!try_set(nxt(pos), rules[i].first.second))
                        return;
                if(rules[i].second == '|')
                    if(!try_set((pos+sz/2)%sz, rules[i].first.second))
                        return;
                urules[level][i] = true;
                updated = true;
            }

            else if(rules[i].first.second > 0 && pnames[level][rules[i].first.second] != -1){
                cout << "use rule " << i << endl;
                int pos = pnames[level][rules[i].first.second];
                if(rules[i].second == '<')
                    if(!try_set(prv(pos), rules[i].first.first))
                        return;
                if(rules[i].second == '>')
                    if(!try_set(nxt(pos), rules[i].first.first))
                        return;
                if(rules[i].second == '|')
                    if(!try_set((pos+sz/2)%sz, rules[i].first.first))
                        return;
                urules[level][i] = true;
                updated = true;
            }
            else if(rules[i].first.second < 0 && pjobs[level][-rules[i].first.second] != -1){
                cout << "use rule " << i << endl;
                int pos = pjobs[level][-rules[i].first.second];
                if(rules[i].second == '<')
                    if(!try_set(prv(pos), rules[i].first.first))
                        return;
                if(rules[i].second == '>')
                    if(!try_set(nxt(pos), rules[i].first.first))
                        return;
                if(rules[i].second == '|')
                    if(!try_set((pos+sz/2)%sz, rules[i].first.first))
                        return;
                urules[level][i] = true;
                updated = true;
            }
        }
    }
    int pos = -1;
    int d = -1;
    for(int i = 0; i < sz; ++i){
        if(table[level][i][0] == 0){
            pos = i;
            d = 0;
            break;
        }
        if(table[level][i][1] == 0){
            pos = i;
            d = 1;
            break;
        }
    }
    cout << pos << ' ' << d << endl;
    if(pos == -1){
        cout << "ANS" << endl;
        return;
    }
    ++level;
    if(d == 0){
        for(int i = 1; i <= sz; ++i){
            if(pnames[level-1][i] != -1)
                continue;
            for(int i = 0; i < sz; ++i){
                pnames[level][i] = pnames[level-1][i];
                pjobs[level][i] = pjobs[level-1][i];
            }
            try_set(pos, i);
            cout << "GO" << endl;
            rec();
        }
    }
    else{
        for(int i = 1; i <= sz; ++i){
            if(pjobs[level-1][i] != -1)
                continue;
            for(int i = 0; i < sz; ++i){
                pnames[level][i] = pnames[level-1][i];
                pjobs[level][i] = pjobs[level-1][i];
            }
            try_set(pos, -i);
            cout << "GO" << endl;
            rec();
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    freopen("party.in", "r", stdin);
    freopen("party.out", "w", stdout);
    string s;
    char c = ',';
    while(c == ','){
        string a, b;
        char r;
        cin >> a >> r >> b;
        c = b[b.size()-1];
        b.erase(b.size()-1);
        rules.push_back(make_pair(make_pair(is_upper(a[0]) ? get_name(a) : -get_job(a), is_upper(b[0]) ? get_name(b) : -get_job(b)), r));
        cout << a << r << b << endl;
    }
    for(int i = 0; i < rules.size(); ++i)
        cout << rules[i].first.first << ' ' << rules[i].first.second << ' ' << rules[i].second << endl;
    sort(all_names.begin(), all_names.end(), comp());
    for(int i = 0; i < all_names.size(); ++i)
        cout << all_names[i] << endl;
    sz = all_names.size();
    table[0][0][0] = get_name(all_names[0]);
    for(int i = 1; i <= sz; ++i){
        pnames[0][i] = -1;
        pjobs[0][i] = -1;
    }
    pnames[0][get_name(all_names[0])] = 0;
    rec();
}

