/* GCC */
#include<iostream>
#include<cstdio>
#include<map>

using namespace std;

const int N = 5+1;
const long long h = 1e3+13;

int n, m;
int a[N], b[N];
map<long long, bool> mp;

bool rec(){
    long long t = 0;
    bool lose = true;
    for(int i = 0; i < n-1; ++i){
        t = t*h + a[i];
        if(a[i] >= b[0])
            lose = false;
    }
    if(mp.find(t) != mp.end())
        return mp[t];
    if(lose)
        return mp[t] = false;
    for(int i = 0; i < n-1; ++i)
        for(int j = 0; j < m; ++j){
            if(a[i] < b[j])
                break;
            a[i] -= b[j];
            a[i+1] += b[j];
            bool ans = rec();
            a[i] += b[j];
            a[i+1] -= b[j];
            if(!ans)
                return mp[t] = true;
        }
    return mp[t] = false;
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    freopen("stones.in", "r", stdin);
    freopen("stones.out", "w", stdout);
    cin >> n >> m;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    for(int i = 0; i < m; ++i)
        cin >> b[i];
    bool ans = rec();
    cout << 2 - ans << endl;
    if(ans){
        for(int i = 0; i < n-1; ++i){
            for(int j = 0; j < m; ++j){
                if(a[i] < b[j])
                    break;
                a[i] -= b[j];
                a[i+1] += b[j];
                long long t = 0;
                for(int i = 0; i < n-1; ++i)
                    t = t*h + a[i];
                if(!mp[t]){
                    cout << a[0];
                    for(int i = 1; i < n; ++i)
                        cout << ' ' << a[i];
                    cout << endl;
                }
                a[i] += b[j];
                a[i+1] -= b[j];
            }
        }
    }
}
