/* GCC */
#include <bits/stdc++.h>

using namespace std;

map<vector<int>, bool> m;

ostream& operator <<(ostream& o, vector<int> vec){
    for(int i = 0; i < vec.size() - 1; i++)
        cout << vec[i] << ' ';
    cout << vec[vec.size() - 1] << '\n';
    return o;
}


bool rec(const vector<int> &moves, vector<int> state){
    if(m.count(state) != 0)
        return m[state];
    bool flag = 0;
    for(int i = 0; i < state.size() - 1; i++)
        for(int j = 0; j < moves.size() && moves[j] <= state[i]; j++){
            state[i] -= moves[j];
            state[i+1] += moves[j];
            flag |= !rec(moves, state);
            state[i] += moves[j];
            state[i+1] -= moves[j];
        }
    return m[state] = flag;
}

int main()
{
    freopen("stones.in", "r", stdin);
    freopen("stones.out", "w", stdout);
    int N, M;
    cin >> N >> M;
    vector<int> state(N), moves(M);
    for(int i = 0; i < N; i++)
        cin >> state[i];
    for(int i = 0; i < M; i++)
        cin >> moves[i];
    if(rec(moves, state) == 1){
        cout << 1 << '\n';
        for(int i = 0; i < state.size(); i++)
            for(int j = 0; j < moves.size() && moves[j] <= state[i]; j++){
                state[i] -= moves[j];
                state[i+1] += moves[j];
                if(m[state] == 0)
                    cout << state;
                state[i] += moves[j];
                state[i+1] -= moves[j];
            }
    }
    else
        cout << 2 << '\n';
    return 0;
}
