/* GCC */
#include <bits/stdc++.h>
#include <string>
#include <map>
#include <vector>

using namespace std;
int n;
string c1="åŪȲ";
string c2="賿";

//m man p prof
int p_r_m[26];
int p_r_p[26];
int m_r_m[26];
int m_r_p[26];

int p_l_m[26];
int p_l_p[26];
int m_l_m[26];
int m_l_p[26];

int p_o_m[26];
int p_o_p[26];
int m_o_m[26];
int m_o_p[26];

int u_m[26];
int u_p[26];

int ans_m[26];
int ans_p[26];

int ri(int i)
{
    if (i<n)
        return i+1;
    return 1;
}

int le(int i)
{
    if (i>1)
        return i-1;
    return n;
}

int op(int i)
{
    return (i-1+n/2)%n+1;
}

bool addman(int pos,int i);

bool addprof(int pos,int i)
{
    if (ans_p[pos]!=0 && ans_p[pos]!=i)
        return false;
    if (ans_p[pos]==i)
        return true;
    ans_p[pos]=i;
    if (m_r_p[i])
    {
        if (!addman(ri(pos),m_r_p[i]))
            return false;
    }
    if (m_l_p[i])
    {
        if (!addman(le(pos),m_l_p[i]))
            return false;
    }
    if (m_o_p[i])
    {
        if (!addman(op(pos),m_o_p[i]))
            return false;
    }
    if (p_r_p[i])
    {
        if (!addprof(ri(pos),p_r_p[i]))
            return false;
    }
    if (p_l_p[i])
    {
        if (!addprof(le(pos),p_l_p[i]))
            return false;
    }
    if (p_o_p[i])
    {
        if (!addprof(op(pos),p_o_p[i]))
            return false;
    }
    return true;
}

bool addman(int pos,int i)
{
    if (ans_m[pos]!=0 && ans_m[pos]!=i)
        return false;
    if (ans_m[pos]==i)
        return true;
    ans_m[pos]=i;
    if (m_r_m[i])
    {
        if (!addman(ri(pos),m_r_m[i]))
            return false;
    }
    if (m_l_m[i])
    {
        if (!addman(le(pos),m_l_m[i]))
            return false;
    }
    if (m_o_m[i])
    {
        if (!addman(op(pos),m_o_m[i]))
            return false;
    }
    if (p_r_m[i])
    {
        if (!addprof(ri(pos),p_r_m[i]))
            return false;
    }
    if (p_l_m[i])
    {
        if (!addprof(le(pos),p_l_m[i]))
            return false;
    }
    if (p_o_m[i])
    {
        if (!addprof(op(pos),p_o_m[i]))
            return false;
    }
    return true;
}

void out();

void perebor(int pos,int step)
{
    if (pos==n+1)
    {
        out();
        return;
    }
    int b_u_m[n+1];
    int b_u_p[n+1];
    int b_ans_m[n+1];
    int b_ans_p[n+1];
    for (int i=1;i<=n;i++)
    {
        b_u_m[i]=u_m[i];
        b_u_p[i]=u_p[i];
        b_ans_m[i]=ans_m[i];
        b_ans_p[i]=ans_p[i];
    }
    if (step==1)
    {
        for (int i=1;i<=n;i++)
            if (!u_m[i])
        {
            u_m[i]=1;
            if (addman(pos,i))
                perebor(pos,2);
            for (int i=1;i<=n;i++)
            {
                u_m[i]=b_u_m[i];
                u_p[i]=b_u_p[i];
                ans_m[i]=b_ans_m[i];
                ans_p[i]=b_ans_p[i];
            }
        }
    }
    else
    {
        for (int i=1;i<=n;i++)
            if (!u_p[i])
        {
            u_p[i]=1;
            if (addprof(pos,i))
                perebor(pos+1,1);
            for (int i=1;i<=n;i++)
            {
                u_m[i]=b_u_m[i];
                u_p[i]=b_u_p[i];
                ans_m[i]=b_ans_m[i];
                ans_p[i]=b_ans_p[i];
            }
        }
    }

}

bool isbig(char t)
{
    for (int i=0;i<33;i++)
        if (c1[i]==t)
        return 1;
    return 0;
}
int n1,n2;
vector<string> q;
map<int,string> man;
map<int,string> prof;
map<string,int> mann;
map<string,int> proff;

void out()
{
   for (int i=1;i<n;i++)
       cout << man[ans_m[i]] << " (" << prof[ans_p[i]] << "), ";
    cout << man[ans_m[n]] << " (" << prof[ans_p[n]] << ")." << '\n';
}

int mano(string s)
{
    if (!mann.count(s))
    {
        q.push_back(s);
        n1++;
        mann[s]=n1;
        man[n1]=s;
        return n1;
    }
    return mann[s];
}

int profo(string s)
{
    if (!proff.count(s))
    {
        n2++;
        proff[s]=n2;
        prof[n2]=s;
        return n2;
    }
    return proff[s];
}

bool comp(string s1,string s2) // for names
{
    int i1=0,i2=0;
    for (int i=0;i<33;i++)
    {
        if (s1[0]==c1[i])
            i1=i;
        if (s2[0]==c1[i])
            i2=i;
    }
    if (i1<i2)
        return 1;
    if (i1>i2)
        return 0;
    int k=min(s1.size(),s2.size());
    for (int u=1;u<k;u++)
    {
        i1=0;
        i2=0;
        for (int i=0;i<33;i++)
    {
        if (s1[u]==c2[i])
            i1=i;
        if (s2[u]==c2[i])
            i2=i;
    }
    if (i1<i2)
        return 1;
    if (i1>i2)
        return 0;
    }
    return s1.size()==k;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	//freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    freopen("party.in","r",stdin);
    freopen("party.out","w",stdout);
    setlocale(LC_ALL, "ukr");

    string s="q";
    string s1,s2,sq;
    int a,b;
    while (s[s.size()-1]!='.')
    {
        getline(cin,s);
        stringstream ss(s);
        ss >> s1 >> sq >> s2;
        s2.resize(s2.size()-1);
        if (isbig(s1[0]))
            a=mano(s1);
        else a=-profo(s1);
        if (isbig(s2[0]))
            b=mano(s2);
        else b=-profo(s2);
        if (sq==">")
        {
            if (a<0)
            {
                if (b<0)
                {
                    p_r_p[-b]=-a;
                    p_l_p[-a]=-b;
                }
                else
                {
                    p_r_m[b]=-a;
                    m_l_p[-a]=b;
                }
            }
            else
            {
                if (b<0)
                {
                    m_r_p[-b]=a;
                    p_l_m[a]=-b;
                }
                else
                {
                    m_r_m[b]=a;
                    m_l_m[a]=b;
                }
            }
        }
        if (sq=="<")
        {
            if (a<0)
            {
                if (b<0)
                {
                    p_l_p[-b]=-a;
                    p_r_p[-a]=-b;
                }
                else
                {
                    p_l_m[b]=-a;
                    m_r_p[-a]=b;
                }
            }
            else
            {
                if (b<0)
                {
                    m_l_p[-b]=a;
                    p_r_m[a]=-b;
                }
                else
                {
                    m_l_m[b]=a;
                    m_r_m[a]=b;
                }
            }
        }
        if (sq=="|")
        {
            if (a<0)
            {
                if (b<0)
                {
                    p_o_p[-b]=-a;
                    p_o_p[-a]=-b;
                }
                else
                {
                    p_o_m[b]=-a;
                    m_o_p[-a]=b;
                }
            }
            else
            {
                if (b<0)
                {
                    m_o_p[-b]=a;
                    p_o_m[a]=-b;
                }
                else
                {
                    m_o_m[b]=a;
                    m_o_m[a]=b;
                }
            }
        }
    }
    n=min(n1,n2);
    sort(q.begin(),q.end(),comp);
    ans_m[1]=mann[*q.begin()];
    perebor(1,2);
    return 0;
}
