/* GCC */
#include <bits/stdc++.h>

using namespace std;

string allLeters = "åŪȲ賿";
string bigLetters = "åŪȲ";

bool cmp(string a, string b) {
    int a_, b_;
    for(int i = 0;i < min(a.size(), b.size());++i) {
        a_ = allLeters.find(a[i]);
        b_ = allLeters.find(b[i]);
        if(a_ != b_)
            return a_ < b_;
    }
    return a.size() < b.size();
}

vector<string> arr;
vector<vector<pair<int, char> > > g;
vector<int> pos[2];
vector<bool> used;
int n;

bool dfs(int v, int where) {
    if(used[v] && pos[v/n][where] != v)
        return false;
    if(used[v])
        return true;
    if(!used[v] && pos[v/n][where] != -1)
        return false;
    pos[v/n][where] = v;
    used[v] = true;

    for(int i = 0;i < g[v].size();++i) {
        if(g[v][i].second == '<' && !dfs(g[v][i].first, (where+1) % n))
            return false;
        if(g[v][i].second == '|' && !dfs(g[v][i].first, (where + n/2) % n))
            return false;
        if(g[v][i].second == '>' && !dfs(g[v][i].first, (where+n-1) % n))
            return false;
    }
    return true;
}
int cnt = 0;
void solve(int k) {
    vector<int> saved_pos[2];
    vector<bool> saved_used;

    bool finish = true;
    for(k;k < n<<1 && finish;++k)
    if(!used[k])
        finish = false;

    if(finish) {
        cnt++;
        for(int i = 0;i < n;++i) {
            cout << arr[pos[0][i]] << " (" << arr[pos[1][i]] << ")";
            if(i == n-1)
                cout << ".\n";
            else
                cout << ", ";
        }
        return;
    }

    saved_pos[0] = pos[0];
    saved_pos[1] = pos[1];
    saved_used = used;
    for(int i = 0;i < n;++i)
    for(int hv = 0;hv < 2;++hv)
    if(pos[hv][i] == -1) {
        for(int j = hv*n;j < n + hv*n;++j) {
            if(dfs(j, i))
                solve(k);
            used = saved_used;
            pos[0] = saved_pos[0];
            pos[1] = saved_pos[1];
        }
        return;
    }
}
int main()
{
    freopen("party.in", "r", stdin);
    freopen("party.out", "w", stdout);
    setlocale(LC_ALL, "ukr");

    stringstream ss;
    string a, b;
    char t;
    set<string> s_arr;
    map<string, int> num;
    while(cin >> a >> t >> b) {
        s_arr.insert(a);
        b.erase(--b.end());
        s_arr.insert(b);
        ss << a << ' ' << t << ' ' << b << '\n';
    }

    arr.reserve(s_arr.size());
    for(set<string>::iterator it = s_arr.begin();it != s_arr.end();++it)
        arr.push_back(*it);
    s_arr.clear();
    n = arr.size()/2;
    sort(arr.begin(), arr.end(), cmp);
    for(int i = 0;i < n<<1;++i)
        num[arr[i]] = i;
    g.resize(n<<1);
    used.resize(n<<1, 0);
    pos[0].resize(n, -1);
    pos[1].resize(n, -1);
    while(ss >> a >> t >> b) {
        g[num[a]].push_back(make_pair(num[b], t));
        if(t == '<')
            t = '>';
        else if(t == '>')
            t = '<';
        g[num[b]].push_back(make_pair(num[a], t));
    }
    num.clear();
    if(dfs(0, 0))
        solve(1);
    if(cnt == 0)
        cout << '\n';
    return 0;
}
