/* GCC */
#include <bits/stdc++.h>
using namespace std;
int n, m1;
vector<int> L;
map<vector<int>, int> m;
vector<vector<int> > ans;

bool F(vector<int>& hills, int step)
{
    if(m[hills])
        return max(0, m[hills]);

    bool control = false;

    for(int i = 0; i < hills.size() - 1; i++)
    {
        if(hills[i] >= L[0])
        {
            control = true;
            break;
        }
    }

    if(!control)
    {
        m[hills] = -1;
        return false;
    }

    bool res_pos = false;

    for(int i = 0; i < hills.size() - 1; i++)
    {
        for(int j = 0; j < L.size(); j++)
        {
            if(L[j] > hills[i])
                break;

            hills[i] -= L[j];
            hills[i + 1] += L[j];
            bool now_pos = F(hills, step + 1);
            if(!now_pos)
                res_pos = true;
            if(!now_pos && step == 1)
                ans.push_back(hills);

            hills[i] += L[j];
            hills[i + 1] -= L[j];
        }
    }

    if(res_pos)
        m[hills] = 1;
    else
        m[hills] = -1;

    return max(0, m[hills]);
}


int main()
{
    freopen("stones.in", "r", stdin);
    freopen("stones.out", "w", stdout);
    cin>> n >> m1;
    vector<int> hills(n);
    L.resize(m1);

    for(int i = 0; i < n; i++)
        cin>> hills[i];

    for(int i = 0; i < m1; i++)
        cin>> L[i];

    bool pos = F(hills, 1);

    if(pos)
    {
        cout<< 1 << "\n";
        for(int i = 0; i < ans.size(); i++)
        {
            for(int j = 0; j < ans[i].size(); j++)
            {
                if(j == ans[i].size() - 1)
                    cout<< ans[i][j] << "\n";
                else
                    cout<< ans[i][j] << ' ';
            }
        }
    }
    else
        cout<< 2 << "\n";


    return 0;
}
